sub printStatus
{
    my ($data, $grouping, $offset, $before, $after) = @_;

    my $start = $offset - $before;
    if($start < 0)
    {
	$start = 0;
    }

    my $end = $offset + $after;
    if ($end > length $data)
    {
	$end = length $data;
    }

    printBytes($data, $grouping, $start, $offset);
    print "\n--------------------\n";
    printBytes($data, $grouping, $offset, $end);
    print "\n";
}


sub printBytes
{
    my ($data, $grouping, $start, $end) = @_;

    my $s = substr $data,$start,$end-$start;

    my $boundry_start = int($start / $grouping) * $grouping;
   
    #@s = unpack ("hH" x (2*(length $s)),$s);

    @s = split(//,$s);
    foreach $s (@s)
    {
	$s =sprintf("%02x",ord $s);
    }


    my $index = $boundry_start;

    while($index < $end)
    {
	printf ("L%03d  ",$index);
	#print initial spaces for lineing up beginning of file
	if($index < $start)
	{
	    my $line_end = $index + $grouping-$start -1;
	    $line_end = $#s unless $line_end < $#s;

	    print "   " x ($start - $index);
	    print join(' ', @s[0 .. $line_end]);
	}
	else {
	    my $line_end = $index + $grouping-1 - $start;
	    $line_end = $#s unless $line_end < $#s;

	    print join(' ', @s[$index-$start  .. $line_end]);
	}

	$index = $index + $grouping;
	print "\n";
    }

}

1;
